# Resolution 025 Maintainers Proposal

- Topic:  Maintainers Proposal
- Date: 05-12-2024
- Deadline:
- Size: Large

## Summary

Create policies on recipe maintainence that meet industry standards, for example the designation of a recipe as stable or not if the recipe meets a certain critera and having named maintainers.

## Details

Currently the CC recipes ecosystem is quite unclear. Some recipes are maintained really well and some are abandoned. 

I propose that we adopt a "stable", "testing", "unstable" designation to help organise our recipes internally and present them in a clearer way externally.

We should take influence from the largest democratic software project [Debian](https://www.debian.org/doc/manuals/developers-reference/pkgs.en.html#) and implement a simplifier system of recipe maintainers to help build trust with our community and potential community members.

### Who are maintainers

Maintainers can be either fedi members, community collaborators or organisation collaborators (such as tech co-ops).

Maintainers will need to provide some way of contacting them e.g. and email address or Matrix handle.

Maintainers are welcome to use a handle/alias.

### Stable

"Stable" recipes must meet the following critera:

- Must have at least one named maintainer (handle is fine) with a matrix or email address and that infomation must be kept up to date in the README
- The upstream project must be considered active and able to respond to security issues
- Security issues in the recipe must be patched within one month of discovery
- Merge requests must be responded to with some form of aknowlegement or feedback within one month
- Has been upgraded in the last three months (if appropriate)
- The status score and README of the project should be kept up to date with relevant infomation

### Testing

"Testing" recipes must meet the following critera:

- Must have at least one named maintainer (handle is fine) with a matrix or email address and that infomation must be kept up to date in the README
- The upstream project must be considered active and able to respond to security issues
- Security issues in the recipe must be patched within one month of discovery

### Unstable

"Unstable" recipes must meet the following critera:
- Must have at least one named maintainer (handle is fine) with a matrix or email address and that infomation must be kept up to date in the README

### Unmaintained

If no one claims active responsibility for a recipe, its git repo will be archived and removed from the recipe catalouge.

## Implementation

- Docs updates to include explanations
- Ongoing coworks to add catergories to all recipes
- Package maintenance status will be added to the README's metdata on all recipes. Rname existing "Status" to Features, use Status for this maintenance status.
- Add maintenance status to be visible on recipes.coopcloud.tech
- Every three months we go through the recipes and garden the status is and ping maintainer's etc.

# Pre-Propose Feedback from community
* ~~Are maintainers community members or fedi members?~~
* ~~Should we add a requirement that stable recipe has to respond to issues and/or PRs within x amount of time?~~
* ~~will there be some form of automated check whether or not a recipe still fulfills a category's criteria?~~
* ~~What happens to recipes not fulfilling any criteria? e.g. having no maintainer. need for another category?~~
